#include <stdio.h>
#include <stdlib.h>
#include "data_structure.h"
#include "global.h"
#include "functions.h"
#include "util.h"

void value(POINT *point, int timeslice){
  POINT scratch_point;
  int i;

  if(Trace){
    our_printf("entered value()\n");
    ++Trace_level;
  }

  allocate_point(&scratch_point);

  while(error_too_large(point, timeslice)){
    grow_point(point->price, scratch_point.price);
    if(is_point_relevant(point, &scratch_point)){
      add_point_to_mesh(&scratch_point, point, timeslice+1);
    
      /* the new point is now the last point in the next timeslice */
      value( &(Time[timeslice+1].element[ Time[timeslice+1].elements-1 ]), timeslice+1);

      point->value_if_held      = mesh_estimate_value(point, timeslice);
      point->value              = dMax(point->value_if_held, point->value_if_exercised);
      point->error              = mesh_estimate_error(point, timeslice);
      point->delta_r            = point->value_if_exercised - point->value_if_held;
    }
  }
  deallocate_point(&scratch_point);

  if(Trace){
    --Trace_level;
    our_printf("exiting value()\n");
  }
}
      
    
